package org.steveshipway.cheshirecat.block;

import java.util.Random;

import org.steveshipway.cheshirecat.CCBlocks;
import org.steveshipway.cheshirecat.lib.Constants;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.Minecraft;
import net.minecraft.client.resources.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.util.EnumWorldBlockLayer;
// Minecraft 1.7
//import cpw.mods.fml.common.registry.GameRegistry;
// Minecraft 1.8
import net.minecraftforge.fml.common.registry.GameRegistry;

// define the AlanBlock.  It is a bit like rock.
public class AlanBlock extends Block {
    private String name = "alanBlock";

	// constructor
    public AlanBlock(){
        super(Material.rock);
        this.setCreativeTab(CreativeTabs.tabBlock);  // which creative mode tab
        this.setLightLevel(0.5F); // 1=full sunlight
        this.setStepSound(soundTypeGlass);  // sound family
        this.setResistance(200.0F);  // resistance to explosions; stone=10, obsidian=2000
        this.setHardness(2.0F); // how long to break; stone=1.5, obsidian=50
        this.setHarvestLevel("wand", 2); // required tool: 0 is wood, 1 iron, 2 diamond, 3 obsidian
        this.setUnlocalizedName(Constants.MODID + "_" + name); // how it is referred to in lang and models
        // Minecraft 1.7
        //this.setBlockName(Constants.MODID + "_" + name); // intenal blockname
        //this.setBlockTextureName(Constants.MODID + ":" + name); // texture filename
        //this.setHarvestLevel("wand",0,0);
        //this.setMaxStackSize(8);
    }
    
    public void registerBlock() {
        GameRegistry.registerBlock(this, this.name);
    }
    
    // ideally, this would be done by the registerBlock() call above...
    public void registerRender() {
		Minecraft.getMinecraft().getRenderItem().getItemModelMesher().register(
				GameRegistry.findItem(Constants.MODID, this.name), 
				0, 
				new ModelResourceLocation(Constants.MODID+":"+this.name, "inventory")
		);
    }
    
    // MC 1.7
    //@Override
    //public Item getItemDropped(int metadata, Random random, int fortune) {
    //    return Item.getItemFromBlock(this);
    //}
    @Override
    public int quantityDropped(Random r)
    {
        return r.nextInt(3);
    }
    


}
